Index: uspace/lib/draw/font/embedded.h
===================================================================
--- uspace/lib/draw/font/embedded.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/font/embedded.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_FONT_EMBEDDED_H_
+#define DRAW_FONT_EMBEDDED_H_
+
+#include "../font.h"
+
+extern font_decoder_t fd_embedded;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/cursor-11x18.c
===================================================================
--- uspace/lib/draw/gfx/cursor-11x18.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/gfx/cursor-11x18.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2008 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#include "cursor-11x18.h"
+
+uint8_t cursor_texture[] = {
+	0x01, 0x00, 0x03, 0x00, 0x05, 0x00, 0x09, 0x00, 0x11, 0x00, 0x21, 0x00,
+	0x41, 0x00, 0x81, 0x00, 0x01, 0x01, 0x01, 0x02, 0x01, 0x04, 0x01, 0x03,
+	0x81, 0x00, 0x89, 0x00, 0x15, 0x01, 0x23, 0x01, 0x21, 0x01, 0xc0, 0x00
+};
+
+uint8_t cursor_mask[] = {
+	0x01, 0x00, 0x03, 0x00, 0x07, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x3f, 0x00,
+	0x7f, 0x00, 0xff, 0x00, 0xff, 0x01, 0xff, 0x03, 0xff, 0x07, 0xff, 0x03,
+	0xff, 0x00, 0xff, 0x00, 0xf7, 0x01, 0xe3, 0x01, 0xe1, 0x01, 0xc0, 0x00
+};
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/cursor-11x18.h
===================================================================
--- uspace/lib/draw/gfx/cursor-11x18.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/gfx/cursor-11x18.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2008 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#ifndef CURSOR_11X18_H_
+#define CURSOR_11X18_H_
+
+#include <sys/types.h>
+
+#define CURSOR_WIDTH   11
+#define CURSOR_HEIGHT  18
+
+extern uint8_t cursor_texture[];
+extern uint8_t cursor_mask[];
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/gfx/font-8x16.h
===================================================================
--- uspace/lib/draw/gfx/font-8x16.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/gfx/font-8x16.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/** @file
+ */
+
+#ifndef FONT_8X16_H_
+#define FONT_8X16_H_
+
+#include <sys/types.h>
+
+#define FONT_GLYPHS     2899
+#define FONT_WIDTH      8
+#define FONT_SCANLINES  16
+
+extern uint16_t fb_font_glyph(const wchar_t);
+extern uint8_t fb_font[FONT_GLYPHS][FONT_SCANLINES];
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/path.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+#include <bool.h>
+#include <malloc.h>
+
+#include "path.h"
+
+struct path {
+	list_t list;
+	double cur_x;
+	double cur_y;
+};
+
+void path_init(path_t *path)
+{
+	list_initialize(&path->list);
+	path->cur_x = 0;
+	path->cur_y = 0;
+}
+
+void path_clear(path_t *path)
+{
+	while (!list_empty(&path->list)) {
+		path_step_t *step = (path_step_t *) list_last(&path->list);
+		list_remove(&step->link);
+		free(step);
+	}
+	path->cur_x = 0;
+	path->cur_y = 0;
+}
+
+void path_get_cursor(path_t *path, double *x, double *y)
+{
+	assert(x);
+	assert(y);
+
+	*x = path->cur_x;
+	*y = path->cur_y;
+}
+
+void path_move_to(path_t *path, double dx, double dy)
+{
+	path_step_t *step = (path_step_t *) malloc(sizeof(path_step_t));
+	if (step) {
+		path->cur_x += dx;
+		path->cur_y += dy;
+		link_initialize(&step->link);
+		step->type = PATH_STEP_MOVETO;
+		step->to_x = path->cur_x;
+		step->to_y = path->cur_y;
+		list_append(&step->link, &path->list);
+		
+	}
+}
+
+void path_line_to(path_t *path, double dx, double dy)
+{
+	path_step_t *step = (path_step_t *) malloc(sizeof(path_step_t));
+	if (step) {
+		path->cur_x += dx;
+		path->cur_y += dy;
+		link_initialize(&step->link);
+		step->type = PATH_STEP_LINETO;
+		step->to_x = path->cur_x;
+		step->to_y = path->cur_y;
+		list_append(&step->link, &path->list);
+	}
+}
+
+void path_rectangle(path_t *path, double x, double y, double width, double height)
+{
+	path_move_to(path, x, y);
+	path_line_to(path, width, 0);
+	path_line_to(path, 0, height);
+	path_line_to(path, -width, 0);
+	path_line_to(path, 0, -height);
+}
+
+/** @}
+ */
Index: uspace/lib/draw/path.h
===================================================================
--- uspace/lib/draw/path.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/path.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_PATH_H_
+#define DRAW_PATH_H_
+
+#include <adt/list.h>
+
+typedef enum {
+	PATH_STEP_MOVETO,
+	PATH_STEP_LINETO
+} path_step_type_t;
+
+typedef struct {
+	link_t link;
+	path_step_type_t type;
+	double to_x;
+	double to_y;
+} path_step_t;
+
+struct path;
+typedef struct path path_t;
+
+extern void path_init(path_t *);
+extern void path_clear(path_t *);
+
+extern void path_get_cursor(path_t *, double *, double *);
+
+extern void path_move_to(path_t *, double, double);
+extern void path_line_to(path_t *, double, double);
+
+extern void path_rectangle(path_t *, double, double, double, double);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/source.c
===================================================================
--- uspace/lib/draw/source.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/source.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,131 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <assert.h>
+
+#include "source.h"
+
+void source_init(source_t *source)
+{
+	transform_identity(&source->transform);
+	source->filter = filter_nearest;
+	
+	source->color = PIXEL(0, 0, 0, 0);
+	source->texture = NULL;
+	source->texture_tile = false;
+
+	source->alpha = PIXEL(255, 0, 0, 0);
+	source->mask = NULL;
+	source->mask_tile = false;
+}
+
+void source_set_transform(source_t *source, transform_t transform)
+{
+	source->transform = transform;
+	transform_invert(&source->transform);
+}
+
+void source_reset_transform(source_t *source)
+{
+	transform_identity(&source->transform);
+}
+
+void source_set_filter(source_t *source, filter_t filter)
+{
+	source->filter = filter;
+}
+
+void source_set_color(source_t *source, pixel_t color)
+{
+	source->color = color;
+}
+
+void source_set_texture(source_t *source, surface_t *texture, bool tile)
+{
+	source->texture = texture;
+	source->texture_tile = tile;
+}
+
+void source_set_alpha(source_t *source, pixel_t alpha)
+{
+	source->alpha = alpha;
+}
+
+void source_set_mask(source_t *source, surface_t *mask, bool tile)
+{
+	source->mask = mask;
+	source->mask_tile = tile;
+}
+
+pixel_t source_determine_pixel(source_t *source, double x, double y)
+{
+	if (source->mask || source->texture) {
+		transform_apply_affine(&source->transform, &x, &y);
+	}
+
+	pixel_t mask_pix;
+	if (source->mask) {
+		mask_pix = source->filter(
+		    surface_pixmap_access(source->mask),
+		    x, y, source->mask_tile);
+	} else {
+		mask_pix = source->alpha;
+	}
+
+	if (!ALPHA(mask_pix)) {
+		return 0;
+	}
+
+	pixel_t texture_pix;
+	if (source->texture) {
+		texture_pix = source->filter(
+		    surface_pixmap_access(source->texture),
+		    x, y, source->texture_tile);
+	} else {
+		texture_pix = source->color;
+	}
+
+	if (ALPHA(mask_pix) < 255) {
+		double ratio = ((double) ALPHA(mask_pix)) / 255.0;
+		double res_a = ratio * ((double) ALPHA(texture_pix));
+		return PIXEL((unsigned) res_a,
+		    RED(texture_pix), GREEN(texture_pix), BLUE(texture_pix));
+	} else {
+		return texture_pix;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/draw/source.h
===================================================================
--- uspace/lib/draw/source.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/source.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,78 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_SOURCE_H_
+#define DRAW_SOURCE_H_
+
+#include <sys/types.h>
+#include <bool.h>
+
+#include <transform.h>
+#include <filter.h>
+
+#include "surface.h"
+
+typedef struct source {
+	transform_t transform;
+	filter_t filter;
+
+	pixel_t color;
+	surface_t *texture;
+	bool texture_tile;
+
+	pixel_t alpha;
+	surface_t *mask;
+	bool mask_tile;
+} source_t;
+
+extern void source_init(source_t *);
+
+extern void source_set_transform(source_t *, transform_t);
+extern void source_reset_transform(source_t *);
+
+extern void source_set_filter(source_t *, filter_t);
+
+extern void source_set_color(source_t *, pixel_t);
+extern void source_set_texture(source_t *, surface_t *, bool);
+
+extern void source_set_alpha(source_t *, pixel_t);
+extern void source_set_mask(source_t *, surface_t *, bool);
+
+extern pixel_t source_determine_pixel(source_t *, double, double);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/draw/surface.c
===================================================================
--- uspace/lib/draw/surface.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/surface.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,175 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <malloc.h>
+#include <mem.h>
+#include <as.h>
+#include <assert.h>
+#include "surface.h"
+
+struct surface {
+	surface_flags_t flags;
+
+	surface_coord_t dirty_x_lo;
+	surface_coord_t dirty_x_hi;
+	surface_coord_t dirty_y_lo;
+	surface_coord_t dirty_y_hi;
+
+	pixelmap_t pixmap;
+};
+
+surface_t *surface_create(surface_coord_t width, surface_coord_t height,
+    pixel_t *pixbuf, surface_flags_t flags)
+{
+	surface_t *surface = (surface_t *) malloc(sizeof(surface_t));
+	if (!surface) {
+		return NULL;
+	}
+	
+	size_t pixbuf_size = width * height * sizeof(pixel_t);
+
+	if (!pixbuf) {
+		if ((flags & SURFACE_FLAG_SHARED) == SURFACE_FLAG_SHARED) {
+			pixbuf = (pixel_t *) as_area_create(AS_AREA_ANY, pixbuf_size,
+			    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE);
+			if (pixbuf == AS_MAP_FAILED) {
+				free(surface);
+				return NULL;
+			}
+		} else {
+			pixbuf = (pixel_t *) malloc(pixbuf_size);
+			if (pixbuf == NULL) {
+				free(surface);
+				return NULL;
+			}
+		}
+
+		memset(pixbuf, 0, pixbuf_size);
+	}
+
+	surface->flags = flags;
+	surface->pixmap.width = width;
+	surface->pixmap.height = height;
+	surface->pixmap.data = pixbuf;
+
+	surface_reset_damaged_region(surface);
+
+	return surface;
+}
+
+void surface_destroy(surface_t *surface)
+{
+	pixel_t *pixbuf = surface->pixmap.data;
+
+	if ((surface->flags & SURFACE_FLAG_SHARED) == SURFACE_FLAG_SHARED)
+		as_area_destroy((void *) pixbuf);
+	else
+		free(pixbuf);
+
+	free(surface);
+}
+
+bool surface_is_shared(surface_t *surface)
+{
+	return ((surface->flags & SURFACE_FLAG_SHARED) == SURFACE_FLAG_SHARED);
+}
+
+pixel_t *surface_direct_access(surface_t *surface)
+{
+	return surface->pixmap.data;
+}
+
+pixelmap_t *surface_pixmap_access(surface_t *surface)
+{
+	return &surface->pixmap;
+}
+
+void surface_get_resolution(surface_t *surface, surface_coord_t *width, surface_coord_t *height)
+{
+	assert(width);
+	assert(height);
+	
+	*width = surface->pixmap.width;
+	*height = surface->pixmap.height;
+}
+
+void surface_get_damaged_region(surface_t *surface, surface_coord_t *x, surface_coord_t *y,
+    surface_coord_t *width, surface_coord_t *height)
+{
+	assert(x);
+	assert(y);
+	assert(width);
+	assert(height);
+
+	*x = surface->dirty_x_lo;
+	*y = surface->dirty_y_lo;
+	*width = surface->dirty_x_lo <= surface->dirty_x_hi ?
+	    (surface->dirty_x_hi - surface->dirty_x_lo) + 1 : 0;
+	*height = surface->dirty_y_lo <= surface->dirty_y_hi ?
+	    (surface->dirty_y_hi - surface->dirty_y_lo) + 1 : 0;
+}
+
+void surface_reset_damaged_region(surface_t *surface)
+{
+	surface->dirty_x_lo = surface->pixmap.width - 1;
+	surface->dirty_x_hi = 0;
+	surface->dirty_y_lo = surface->pixmap.height - 1;
+	surface->dirty_y_hi = 0;
+}
+
+void surface_put_pixel(surface_t *surface, surface_coord_t x, surface_coord_t y, pixel_t pixel)
+{
+	surface->dirty_x_lo = surface->dirty_x_lo > x ? x : surface->dirty_x_lo;
+	surface->dirty_x_hi = surface->dirty_x_hi < x ? x : surface->dirty_x_hi;
+	surface->dirty_y_lo = surface->dirty_y_lo > y ? y : surface->dirty_y_lo;
+	surface->dirty_y_hi = surface->dirty_y_hi < y ? y : surface->dirty_y_hi;
+
+	if (x < surface->pixmap.width && y < surface->pixmap.height) {
+		pixelmap_put_pixel(&surface->pixmap, x, y, pixel);
+	}
+}
+
+pixel_t surface_get_pixel(surface_t *surface, surface_coord_t x, surface_coord_t y)
+{
+	if (x < surface->pixmap.width && y < surface->pixmap.height) {
+		return pixelmap_get_pixel(&surface->pixmap, x, y);
+	} else {
+		return 0;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/draw/surface.h
===================================================================
--- uspace/lib/draw/surface.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/lib/draw/surface.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup draw
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef DRAW_SURFACE_H_
+#define DRAW_SURFACE_H_
+
+#include <sys/types.h>
+#include <bool.h>
+#include <io/pixelmap.h>
+
+struct surface;
+typedef struct surface surface_t;
+
+typedef sysarg_t surface_coord_t;
+
+typedef enum {
+	SURFACE_FLAG_NONE = 0,
+	SURFACE_FLAG_SHARED = 1
+} surface_flags_t;
+
+extern surface_t *surface_create(surface_coord_t, surface_coord_t, pixel_t *, surface_flags_t);
+extern void surface_destroy(surface_t *);
+
+extern bool surface_is_shared(surface_t *);
+extern pixel_t *surface_direct_access(surface_t *);
+extern pixelmap_t *surface_pixmap_access(surface_t *);
+extern void surface_get_resolution(surface_t *, surface_coord_t *, surface_coord_t *);
+extern void surface_get_damaged_region(surface_t *, surface_coord_t *, surface_coord_t *,
+    surface_coord_t *, surface_coord_t *);
+extern void surface_reset_damaged_region(surface_t *);
+
+extern void surface_put_pixel(surface_t *, surface_coord_t, surface_coord_t, pixel_t);
+extern pixel_t surface_get_pixel(surface_t *, surface_coord_t, surface_coord_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/drv/Makefile
===================================================================
--- uspace/lib/drv/Makefile	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/drv/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -40,4 +40,5 @@
 	generic/remote_hw_res.c \
 	generic/remote_char_dev.c \
+	generic/remote_graph_dev.c \
 	generic/remote_nic.c \
 	generic/remote_usb.c \
Index: uspace/lib/drv/generic/dev_iface.c
===================================================================
--- uspace/lib/drv/generic/dev_iface.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/drv/generic/dev_iface.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -41,4 +41,5 @@
 #include "remote_hw_res.h"
 #include "remote_char_dev.h"
+#include "remote_graph_dev.h"
 #include "remote_nic.h"
 #include "remote_usb.h"
@@ -52,4 +53,5 @@
 		&remote_hw_res_iface,
 		&remote_char_dev_iface,
+		&remote_graph_dev_iface,
 		&remote_nic_iface,
 		&remote_pci_iface,
